function draw(x)  //x=(x,y,theta,deltav,deltag,v,w)
   rouge=5;bleu=2;blanc=8;vert=3;noir=0;
   theta=x(3);   deltav=x(4); deltag=x(5);
   coque=[-1  4 5  5 4 -1 -1 -1; -2 -2 -1 1 2 2  -2 -2 ; ones(1:8)] ;
   voile=[-5*L 0;0 0;1 1];  
   gouvernail=[-1 1;0 0;1 1];
   [fv,fg]=forces(x);
   Mfv=[-L -L;0 -fv/100;1 1];
   Mfg=[0 0;0 fg/100;1 1];
   R=[cos(theta),-sin(theta),x(1);sin(theta),cos(theta),x(2);0 0 1];
   coque=R*coque;    
   Rdeltav=[cos(deltav),-sin(deltav),3;sin(deltav),cos(deltav),0;0 0 1];
   Rdeltag=[cos(deltag),-sin(deltag),-1;sin(deltag),cos(deltag),0;0 0 1];
   voile=R*Rdeltav*voile;
   Mfv=R*Rdeltav*Mfv;
   gouvernail=R*Rdeltag*gouvernail;
   Mfg=R*Rdeltag*Mfg;
   xbasc();
   xset('thickness',2);
   xsetech([0 0 1 1],[xmin ymin xmax ymax]);
   xset('color',noir);
   xarrows([xmin+5,xmin+5],[ymax,ymax-V],2,bleu)
   xpoly(coque(1,:),coque(2,:))
   xset('color',5)
   xpoly(voile(1,:),voile(2,:))
   xpoly(gouvernail(1,:),gouvernail(2,:))
   xset('color',3)
   xset('thickness',1);
   xarrows(Mfv(1,:),Mfv(2,:),1,vert)
   xarrows(Mfg(1,:),Mfg(2,:),1,vert)
endfunction;
//---------------------------------------------
function [fv,fg]=forces(x)  //x=(x,y,theta,deltav,deltag,v,w)
     theta=x(3);deltav=x(4);deltag=x(5);vitesse=x(6);omega=x(7);
     fv=alphav*V*cos(theta+deltav)-alphav*vitesse*sin(deltav)
     fg=alphag*vitesse*sin(deltag);
endfunction;
//---------------------------------------------
function Dx=f(x,u)  //x=(x,y,theta,deltav,deltag,v,w)
     theta=x(3);deltav=x(4);deltag=x(5);vitesse=x(6);omega=x(7);
     [fv,fg]=forces(x);
     Dx=[vitesse*cos(theta);
        vitesse*sin(theta)-beta*V;
        omega;    
       	u(1);u(2);
       	(1/m)*( fv*sin(deltav)-fg*sin(deltag)-vitesse*alphaf);
        (1/J)*((L-rv*cos(deltav))*fv-rg*fg*cos(deltag)-alphatheta*omega);
       ];
endfunction;
//---------------------------------------------
function u=regul(x,w)
     theta=x(3);deltav=x(4);deltag=x(5);vitesse=x(6);omega=x(7);
     [fv,fg]=forces(x);
     D1theta=omega;
     D1vitesse=(1/m)*( fv*sin(deltav)-fg*sin(deltag)-vitesse*alphaf);
     D1omega= (1/J)*((L-rv*cos(deltav))*fv-rg*fg*cos(deltag)-alphatheta*omega);
     A1=[1,0;0,0];
     A2=[0,0;L/J-rv/J*cos(deltav),-rg/J*cos(deltag)];
     A3=[-alphav*(V*sin(theta+deltav)+vitesse*cos(deltav)),0;0,alphag*vitesse*cos(deltag)];
     b1=[-alphaf/m*D1vitesse;-alphatheta/J*D1omega];
	   b2=[-alphav*(V*omega*sin(theta+deltav)+D1vitesse*sin(deltav));alphag*D1vitesse*sin(deltag)];
	   A=A1+A2*A3;
	   b=A2*b2+b1;
	   u=inv(A)*((w-[deltav;theta+3*omega+3*D1omega])-b);
endfunction;
//---------------------------------------------
xmin=-45;ymin=-30;xmax=45;ymax=30;
L=1;											//	distance mat-centre de pousse de la voile
alphaf=3*20; 								//	frottement de l'eau
alphatheta=25*20; //	frottement angulaire de l'eau
alphav=100; 	//	portance de la voile
alphag=15*20; 	//	portance du gouvernail
beta=0.05;     //drive du bateau
rv=1; 		//	distance de G  la voile
rg=2; 		//	distance de G au gouvernail 
V=10;	//	vent (m/sec)
m=1000;		//	masse du bateau en kg
J=2000;		//	moment d'inertie
x0=[0;0;-0.5;0;0.0;2;0];   //x=(x,y,theta,deltav,deltag,v,w)
x=x0;
u=[0;0];
dt=0.01;
for k=1:5000,
        cap=k/300;
        w=[%pi/4;0];
        u=regul(x,w);
        x=x+f(x,u)*dt;
    				if or([x(1)>xmax,x(1)<xmin,x(2)>ymax,x(2)<ymin]) then 
		     	x(1)=0;x(2)=0;
        end			
        draw(x);
end;
