//------------------------------------------------------
function draw_segway2d(x)  //  Dessin du segway imagin par le rgulateur
    l=1; R=0.5;
    rouge=5;bleu=2;blanc=8;vert=3;noir=0;magenta=6;
    M=[0.3*l*[0 1 1.5 0 -1.5 -1 0; 0 1 6 6.3 6 1 0]; 1 1 1 1 1 1 1] ;
    a=-R*x(1);
    M=[cos(x(2)),-sin(x(2)),a;sin(x(2)),cos(x(2)),0;0 0 1]*M;
    xbasc(); xset("pixmap",1);
    xset('thickness',2);
    ech=3;
    isoview(-ech,ech,-ech,ech);
    xset('color',noir);
    xpoly(M(1,:),M(2,:));
    xset('color',magenta);
    for k=1:8,
      b=x(1)+k*%pi/4;
      Mrayon=[cos(b),-sin(b),a;sin(b),cos(b),0;0 0 1]*[-R R;0 0;1 1]
      xpoly(Mrayon(1,:),Mrayon(2,:));
    end
    xarc(a-R,R,2*R,2*R,0,0);
    xset('color',bleu);
    xarc(-R*w-R,R,2*R,2*R,0,0);
endfunction;
//------------------------------------------------------
function draw_segway3d(xd,yd,theta,psi,alpha1,alpha2)  
    l=1; R=0.5;
    rouge=5;bleu=2;blanc=8;vert=3;noir=0;magenta=6;
    t=0:0.1:2*%pi;
    Mrleft=[cos(t);-ones(t);sin(t);ones(t)];
    Mrright=[cos(t);ones(t);sin(t);ones(t)];
    Mcorps=[0  0   0   0   0;
           -1 -0.1 0  0.1  1;
            0  0   2   0   0;
            1  1   1   1   1]
    Mseg=[Mrleft,Mcorps,Mrright];
    
    sq2 = sqrt(2)/2;
    Mrayon = [  0 1 -1 0 0 0 0 sq2 -sq2 0 -sq2 sq2;
		0 0 0 0 0 0 0 0 0 0 0 0;
		0 0 0 0 1 -1 0 sq2 -sq2 0 sq2 -sq2;
		1 1 1 1 1 1 1 1 1 1 1 1] ;

    Ralpha1=[cos(alpha1),0,sin(alpha1),0;0,1,0,0;-sin(alpha1),0,cos(alpha1),0;0 0 0 1];
    Ralpha2=[cos(alpha2),0,sin(alpha2),0;0,1,0,0;-sin(alpha2),0,cos(alpha2),0;0 0 0 1];
    MTrans1 = eye(4,4);    MTrans1(1:3,4) = [0 ;-1 ;0];
    MTrans2 = eye(4,4);    MTrans2(1:3,4) = [0 ;1 ;0];

    Rtheta=[cos(theta),0,sin(theta),0;0,1,0,0;-sin(theta),0,cos(theta),0;0 0 0 1];
    Rpsi=[cos(psi),-sin(psi),0,xd;sin(psi),cos(psi),0,yd;0 0 1 0;0 0 0 1];
    phi=-0.2;
    Rcam=[1 0 0 0;0 cos(phi),-sin(phi),1;0 sin(phi),cos(phi),0;0 0 0 1];
    Mr=Rcam*Rpsi*Rtheta*Mseg;

    MrayonRight = Rcam*Rpsi*Ralpha1*MTrans2*Mrayon;
    MrayonLeft = Rcam*Rpsi*Ralpha2*MTrans1*Mrayon;

    xset('color',noir);    xpoly(Mr(1,:),Mr(3,:));
    xset('thickness',1);
    xset('color',bleu);    xpoly(MrayonRight(1,:),MrayonRight(3,:));
    xset('color',vert);    xpoly(MrayonLeft(1,:),MrayonLeft(3,:));
    xset("wshow");
endfunction;
//------------------------------------------------------
function dx=f(x,u) 
    theta=x(1);  dalpha=x(2); dtheta=x(3); xc=x(4);  yc=x(5); psi=x(6); alpha1=x(7); alpha2=x(8);
    c1=cos(x(1));s1=sin(x(1))
    den=2-c1^2;
    w2=dtheta^2;
    ddalpha=(1/den)*((2*w2-5*c1)*s1+(2+c1)*u(1));
    ddtheta=(1/den)*((5-w2*c1)*s1-(1+c1)*u(1));
    dx=[ dtheta;
         ddalpha;
         ddtheta;
         cos(psi)*dalpha;
         sin(psi)*dalpha;
         u(2);
         dalpha-u(2);
         dalpha+u(2);
        ];
endfunction;
//------------*------------------------------------------
x=[0;0;0;0;0;0;0;0];   // x=[theta,dalpha,dtheta,x,y,psi,alpha1,alpha2]
dt=0.005;
u=[0;0];

// Construction du rgulateur qui s'imagine un monde en 2D
xr2=[0;0;0;0];  //tat initial de l'observateur 
A2=[0 0 1 0;0 0 0 1;0 -5 0 0;0 5 0 0]; 
B2=[0;0;3;-2];
C2=[1 0 0 0];
E2=[1 0 0 0];
K2=ppol(A2,B2,[-1,-1,-1,-1]);
L2=ppol(A2',C2',[-1,-1,-1,-1])';
H2=-inv(E2*inv(A2-B2*K2)*B2);
Ar2=A2-B2*K2-L2*C2;
Br2=[B2*H2 L2];
Cr2=-K2;
// Le rgulateur est maintenant construit 
C=[0 0 0 0 0 0 0.5 0.5]; // matrice d'observation du systme. 
                         // On mesure la moyenne entre les angles des deux roues
w=0;   // consigne en position
for t=0:dt:30,
     w=w+0.5*dt;  // On fait voluer la consigne pour que le segway avance.
                  // Cette consigne correspond  l'angle moyen entre les 2 roues,
                  // ou si on prfre  la distance parcourue par le segway.
     u=[Cr2*xr2+H2*w;0.1];  //u1 correspond au couple calcul par le rgulateur 2D
                             //u2, est une vitesse de rotation demande par le conducteur du segway
                             
     y=C*x+0.03*rand();      // mesure gnre par le capteur.
     draw_segway2d(xr2);     //Ici, on dessine le segway vu par le rgulateur, qui s'imagine un monde en 2D
     theta=x(1);  xc=x(4);  yc=x(5); psi=x(6); alpha1=x(7); alpha2=x(8);
     draw_segway3d(xc,yc,theta,psi,alpha1,alpha2);   // On dessine le vrai segway en 3d.
     x=x+f(x,u)*dt;
     xr2=xr2+(Ar2*xr2+Br2*[w;y])*dt;	
end
xdel();
//------------------------------------------------------








