//------------------------------------------------------
function draw_segway3d(xd,yd,theta,psi,alpha1,alpha2)
    ech=2;  //echelle
    l=1; R=0.5;
    rouge=5;bleu=2;blanc=8;vert=3;noir=0;magenta=6;
    t=0:0.1:2*%pi;
    Mrleft=[cos(t);-ones(t);sin(t);ones(t)];
    Mrright=[cos(t);ones(t);sin(t);ones(t)];
    Mcorps=[0  0   0   0   0;
           -1 -0.1 0  0.1  1;
            0  0   2   0   0;
            1  1   1   1   1]
    Mseg=[Mrleft,Mcorps,Mrright];
    
    sq2 = sqrt(2)/2;
    Mrayon = [  0 1 -1 0 0 0 0 sq2 -sq2 0 -sq2 sq2;
		0 0 0 0 0 0 0 0 0 0 0 0;
		0 0 0 0 1 -1 0 sq2 -sq2 0 sq2 -sq2;
		1 1 1 1 1 1 1 1 1 1 1 1] ;

    Ralpha1=[cos(alpha1),0,sin(alpha1),0;0,1,0,0;-sin(alpha1),0,cos(alpha1),0;0 0 0 1];
    Ralpha2=[cos(alpha2),0,sin(alpha2),0;0,1,0,0;-sin(alpha2),0,cos(alpha2),0;0 0 0 1];
    MTrans1 = eye(4,4);    MTrans1(1:3,4) = [0 ;-1 ;0];
    MTrans2 = eye(4,4);    MTrans2(1:3,4) = [0 ;1 ;0];

    Rtheta=[cos(theta),0,sin(theta),0;0,1,0,0;-sin(theta),0,cos(theta),0;0 0 0 1];
    Rpsi=[cos(psi),-sin(psi),0,xd;sin(psi),cos(psi),0,yd;0 0 1 0;0 0 0 1];
    phi=-0.2;
    Rcam=[1 0 0 0;0 cos(phi),-sin(phi),1;0 sin(phi),cos(phi),0;0 0 0 1];
    Mr=Rcam*Rpsi*Rtheta*Mseg;

    MrayonRight = Rcam*Rpsi*Ralpha1*MTrans2*Mrayon;
    MrayonLeft = Rcam*Rpsi*Ralpha2*MTrans1*Mrayon;

   xbasc(); xset("pixmap",1);
   ech=3;
   xset('thickness',3);
   isoview(-ech,ech,-ech,ech);
    xset('color',noir);    xpoly(Mr(1,:),Mr(3,:));
   xset('thickness',1);
    xset('color',bleu);    xpoly(MrayonRight(1,:),MrayonRight(3,:));
    xset('color',vert);    xpoly(MrayonLeft(1,:),MrayonLeft(3,:));
    xset("wshow");
endfunction;
//------------------------------------------------------
function dx=f(x,u) 
    theta=x(1);  dalpha=x(2); dtheta=x(3); xc=x(4);  yc=x(5); psi=x(6); alpha1=x(7); alpha2=x(8);
    c1=cos(x(1));s1=sin(x(1))
    den=2-c1^2;
    w2=dtheta^2;
    ddalpha=(1/den)*((2*w2-5*c1)*s1+(2+c1)*u(1));
    ddtheta=(1/den)*((5-w2*c1)*s1-(1+c1)*u(1));
    dx=[ dtheta;
         ddalpha;
         ddtheta;
         cos(psi)*dalpha;
         sin(psi)*dalpha;
         u(2);
         dalpha-u(2);
         dalpha+u(2);
        ];
endfunction;
//------------*------------------------------------------
x=[0.1;1.5;0;0;0;0;0;0];   // x=[theta,dalpha,dtheta,x,y,psi,alpha1,alpha2]
dt=0.002;
u=[0;0.2];
for t=0:dt:20,
  theta=x(1);  xd=x(4);  yd=x(5); psi=x(6); alpha1=x(7); alpha2=x(8);
  draw_segway3d(xd,yd,theta,psi,alpha1,alpha2);
  x=x+f(x,u)*dt;
end
xdel();
//------------------------------------------------------








