//---------------------------------------------
//  VoitureAsservieCircuit.sce
//---------------------------------------------
function my_eventhandler(win,x,y,ibut)   //(handler = baggagiste)
       global r0 v0 sortie ech I;
       xinfo(' Rglage Zoom : z,Z; Rayon : R,r; Vitesse : V,V, Effet Intgral : i; Fin : F;')
       if ascii(ibut)=='R' then r0=r0+0.1; end   
       if ascii(ibut)=='r' then r0=r0-0.1; end   
       if ascii(ibut)=='V' then v0=v0+0.5; end   
       if ascii(ibut)=='v' then v0=v0-0.5; end   
       if ascii(ibut)=='z' then ech=ech*0.95; end   
       if ascii(ibut)=='Z' then ech=ech/0.95; end   
       if ascii(ibut)=='F' then sortie=%T;    end   
endfunction

//------------------------------------------------------
function [Ar,Br,Cr,Dr]=RegulKLH(A,B,C,E,pcom,pobs);
		K=ppol(A,B,pcom);
		L=ppol(A',C',pobs)';
		H=-inv(E*inv(A-B*K)*B);
		Ar=A-B*K-L*C;		Br=[B*H L];
		Cr=-K;			Dr=[H,zeros(B'*C')]  
endfunction
//---------------------------------------------
function draw(x,y)
   M=[-1  4 5  5 4 -1 -1   -1 0  0  -1  1  0 0 -1 1 0 0 3 3 3;  //Chassis
      -2 -2 -1 1 2 2  -2   -2 -2 -3 -3 -3 -3 3  3 3 3 2 2 3 -3;
      ones(1:21)] ;
   Rav=[-1 1;0 0;1 1];  //Motif d'une roue avant
   R=[cos(x(3)),-sin(x(3)),x(1);sin(x(3)),cos(x(3)),x(2);0 0 1];
   M=R*M;    
   Ravd=R*[cos(x(5)),-sin(x(5)) 3;sin(x(5)),cos(x(5)) 3 ;0 0 1]*Rav;
   Ravg=R*[cos(x(5)),-sin(x(5)) 3;sin(x(5)),cos(x(5)) -3;0 0 1]*Rav;

   rouge=5;bleu=2;blanc=8;vert=3;noir=0;magenta=6;
   xset('font',2,3);
   xbasc();
   isoview(-ech,ech,-ech,ech)
   xset("thickness",2);  xset("color",noir);
   xfpoly(Aj(1,:),Aj(2,:));
   xpoly(M(1,:),M(2,:))
   xpoly(Ravd(1,:),Ravd(2,:))
   xpoly(Ravg(1,:),Ravg(2,:))
   //laser
   xset("color",rouge); xpoly([x(1),x(1)+sin(x(3))*y(1)],[x(2),x(2)-cos(x(3))*y(1)]);
endfunction;
//---------------------------------------------
function v=f(x,u)  //fonction d'volution
    v=[x(4)*cos(x(5))*cos(x(3));
       x(4)*cos(x(5))*sin(x(3));
       x(4)*sin(x(5))/3;
       u(1);u(2) ];
endfunction;
//---------------------------------------------
function y=g(x)  //fonction d'observation
	u=[sin(x(3));-cos(x(3))];
	m=[x(1);x(2)];
  	d=%inf;
  	for j=1:size(Aj,2)
 	   a=Aj(:,j);
    	   b=Bj(:,j);
    	   if (det([a-m u])*det([b-m u]) <= 0)&(det([a-m b-a])/det([u b-a])>=0)
		     d=min(det([a-m b-a])/det([u b-a]),d);
      	   end
  	end
 	y=[d;x(4);x(5)];
endfunction
//---------------------------------------------
global r0 v0 sortie ech ;
r0=5; v0=7; sortie=%F; ech=25;
Aj=[-10 -10   0 10  20  32 35 30  20  0   ;    
     -5  5   15 20  20  15 10  0  -3  -6   ];
Bj=[Aj(:,2:$),Aj(:,1)];
A=[0 7 0 0;0 0 0 7/3;0 0 0 0;0 0 0 0];
B=[0 0;0 0;1 0;0 1];
C=[1 0 0 0;0 0 1 0;0 0 0 1];
E=[1 0 0 0;0 0 1 0];
[Ar,Br,Cr,Dr]=RegulKLH(A,B,C,E,[-2 -2 -2 -2],[-2 -2 -2 -2])
ubar=[0;0];
xbar=[r0;1.57;v0;0];
wbar=E*xbar;
ybar=[xbar(1)/sin(xbar(2));xbar(3);xbar(4)];
xr=[0;0;0;0];
x=[-15;0;%pi/2;7;0.1];y=g(x); 
dt=0.01;
t=0;
seteventhandler('my_eventhandler');
while sortie==%F, 
        t=t+dt;
        w=[r0;v0];
        u=ubar+Cr*xr+Dr*[w-wbar;y-ybar];
        y=g(x);    
        x1=x+f(x,u)*dt;
        xr1=xr+(Ar*xr+Br*[w-wbar;y-ybar])*dt;
        draw(x,y); 	
        x=x1;xr=xr1;
end;
seteventhandler('') //suppress the event handler
xdel();






