//---------------------------------------------
//  VoitureAsservieNord.sce
//------------------------------------------------------
function [Ar,Br,Cr,Dr]=RegulKLH(A,B,C,E,pcom,pobs);
		K=ppol(A,B,pcom);
		L=ppol(A',C',pobs)';
		H=-inv(E*inv(A-B*K)*B);
		Ar=A-B*K-L*C;		Br=[B*H L];
		Cr=-K;			Dr=[H,zeros(B'*C')]  
endfunction
//---------------------------------------------
function draw(x,y)
   xbasc();xset("thickness",2);  xset("color",0);
   xsetech([0 0 1 1],[-40 -20 20 20]);
   xfpoly([0,0],[-13 13]);	
   theta=x(2);    delta=x(4);
   M=[-1  4 5  5 4 -1 -1   -1 0  0  -1  1  0 0 -1 1 0 0 3 3 3;  //Chassis
      -2 -2 -1 1 2 2  -2   -2 -2 -3 -3 -3 -3 3  3 3 3 2 2 3 -3;
      ones(1:21)] ;
   Rav=[-1 1;0 0;1 1];  //Motif d'une roue avant
   R=[cos(theta),-sin(theta),-x(1);sin(theta),cos(theta),0;0 0 1];
   M=R*M;    
   Ravd=R*[cos(delta),-sin(delta) 3;sin(delta),cos(delta) 3 ;0 0 1]*Rav;
   Ravg=R*[cos(delta),-sin(delta) 3;sin(delta),cos(delta) -3;0 0 1]*Rav;
   xpoly(M(1,:),M(2,:),'lines',0)
   xpoly(Ravd(1,:),Ravd(2,:))
   xpoly(Ravg(1,:),Ravg(2,:))
   xset("color",5);    //rayon
   xpoly([-x(1),-x(1)+sin(x(2))*y(1)],[0,-cos(x(2))*y(1)]);
endfunction;
//---------------------------------------------
function v=f(x,u)  //fonction d'volution
 	v=[ -x(3)*cos(x(4))*cos(x(2));
       	     x(3)*sin(x(4))/3;
       	     u(1);u(2) ];
endfunction;
//---------------------------------------------
function y=g(x)  //fonction d'observation
	y=[x(1)/sin(x(2));x(3);x(4)]
endfunction
//---------------------------------------------
rand('normal');
A=[0 7 0 0;0 0 0 7/3;0 0 0 0;0 0 0 0];
B=[0 0;0 0;1 0;0 1];
C=[1 0 0 0;0 0 1 0;0 0 0 1];
E=[1 0 0 0;0 0 1 0];
[Ar,Br,Cr,Dr]=RegulKLH(A,B,C,E,[-2 -2 -2 -2],[-2 -2 -2 -2]);
ubar=[0;0];
xbar=[5;1.57;7;0];
wbar=E*xbar;
ybar=g(xbar);
x=[5.5;1.7;6.7;0.1]; 
xr=[0;0;0;0];
w=[5;7];
dt=0.01;
for k=1:6000,
  y=g(x)+0.15*rand(3,1);
	u=ubar+Cr*xr+Dr*[w-wbar;y-ybar];
  x1=x+f(x,u)*dt;
  xr1=xr+(Ar*xr+Br*[w-wbar;y-ybar])*dt;
	draw(x,y);
	x=x1;
  xr=xr1;
end;
