//---------------------------------------------
//  VoitureLibreCircuit.sce
//---------------------------------------------
function draw(x,y)
   M=[-1  4 5  5 4 -1 -1   -1 0  0  -1  1  0 0 -1 1 0 0 3 3 3;  //Chassis
      -2 -2 -1 1 2 2  -2   -2 -2 -3 -3 -3 -3 3  3 3 3 2 2 3 -3;
      ones(1:21)] ;
   Rav=[-1 1;0 0;1 1];  //Motif d'une roue avant
   R=[cos(x(3)),-sin(x(3)),x(1);sin(x(3)),cos(x(3)),x(2);0 0 1];
   M=R*M;    
   Ravd=R*[cos(x(5)),-sin(x(5)) 3;sin(x(5)),cos(x(5)) 3 ;0 0 1]*Rav;
   Ravg=R*[cos(x(5)),-sin(x(5)) 3;sin(x(5)),cos(x(5)) -3;0 0 1]*Rav;
   xbasc();   xsetech([0 0 1 1],[-20 -10 -20+3*25 -10+2*25]); 
   xset("thickness",2);  xset("color",0);
   xfpoly(Aj(1,:),Aj(2,:));
   xpoly(M(1,:),M(2,:),'lines',0)
   xpoly(Ravd(1,:),Ravd(2,:))
   xpoly(Ravg(1,:),Ravg(2,:))
   //laser
   xset("color",5); xpoly([x(1),x(1)+sin(x(3))*y(1)],[x(2),x(2)-cos(x(3))*y(1)]);
endfunction;
//---------------------------------------------
function v=f(x,u)  //fonction d'volution
    v=[x(4)*cos(x(5))*cos(x(3));
          x(4)*cos(x(5))*sin(x(3));
          x(4)*sin(x(5))/3;
          u(1);u(2) ];
endfunction;
//---------------------------------------------
function y=g(x)  //fonction d'observation
	u=[sin(x(3));-cos(x(3))];
	m=[x(1);x(2)];
  	d=%inf;
  	for j=1:size(Aj,2)
 	   a=Aj(:,j);
    	   b=Bj(:,j);
    	   if (det([a-m u])*det([b-m u]) <= 0)&(det([a-m b-a])/det([u b-a])>=0)
		     d=min(det([a-m b-a])/det([u b-a]),d);
      	   end
  	end
 	y=[d;x(4);x(5)];
endfunction
//---------------------------------------------
Aj=[-10 -10   0 10  20  32 35 30  20  0;-5 5  15 20  20  15 10  0  -3  -6   ];
Bj=[Aj(:,2:$),Aj(:,1)];
x=[-20;0;1.57;7;-0.15]
u=[0;0];
dt=0.01;
for k=1:3500,
        y=g(x);    
	draw(x,y);
	x1=x+f(x,u)*dt;
        x=x1;
end;
