//---------------------------------------------
//  VoitureLibreNord.sce
//---------------------------------------------
function draw(x,y)
   xbasc();xset("thickness",2);  xset("color",0);
   xsetech([0 0 1 1],[-40 -20 20 20]);
   xfpoly([0,0],[-13 13]);	
   theta=x(2);    delta=x(4);
   M=[-1  4 5  5 4 -1 -1   -1 0  0  -1  1  0 0 -1 1 0 0 3 3 3;  //Chassis
      -2 -2 -1 1 2 2  -2   -2 -2 -3 -3 -3 -3 3  3 3 3 2 2 3 -3;
      ones(1:21)] ;
   Rav=[-1 1;0 0;1 1];  //Motif d'une roue avant
   R=[cos(theta),-sin(theta),-x(1);sin(theta),cos(theta),0;0 0 1];
   M=R*M;    
   Ravd=R*[cos(delta),-sin(delta) 3;sin(delta),cos(delta) 3 ;0 0 1]*Rav;
   Ravg=R*[cos(delta),-sin(delta) 3;sin(delta),cos(delta) -3;0 0 1]*Rav;
   xpoly(M(1,:),M(2,:),'lines',0)
   xpoly(Ravd(1,:),Ravd(2,:))
   xpoly(Ravg(1,:),Ravg(2,:))
   xset("color",5);    //rayon
   xpoly([-x(1),-x(1)+sin(x(2))*y(1)],[0,-cos(x(2))*y(1)]);
endfunction;
//---------------------------------------------
function v=f(x,u)  //fonction d'volution
    v=[-x(3)*cos(x(4))*cos(x(2));
       x(3)*sin(x(4))/3;
       u(1);u(2) ];
endfunction;
//---------------------------------------------
function y=g(x)  //fonction d'observation
	y=[x(1)/sin(x(2));x(3);x(4)]
endfunction
//---------------------------------------------
x=[4;1.3;7;0.1];
u=[0;0];
dt=0.002;
for k=1:2500,
  y=g(x);    
  draw(x,y);
  x1=x+f(x,u)*dt;
	x=x1;
end;
